//Serena Bailey ITDEV140 Downtown Campus AM
package bailey_guicustomhomes;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
  
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.DefaultTableModel;

public class CRUD {
    //to connect to database
    final String DB_URL = "jdbc:derby://localhost:1527/HomeOrdersDB;user=sa;password=sa;create=true";
    
    //declarations for database and various command outputs.
    String SQLString;
    Connection conn;
    public PreparedStatement pstmt; 
    public Statement stmt; 
    public ResultSet rs;
    CustomHomesForm gui;
    
    public CRUD(CustomHomesForm gui)
    {
        System.out.println("In constructor");
        try {
          conn = DriverManager.getConnection(DB_URL);
        } catch (SQLException ex) {
            Logger.getLogger(CRUD.class.getName()).log(Level.SEVERE, null, ex);
        }
        if (this.conn != null)
        {
           System.out.println("***Connected To Database***");
        }
        this.gui = gui;      
    }
   
    public void showTable()
    {
        ArrayList<Homes> homes = getHomes();
        
        //convert form's JTable to a Default Table.
        DefaultTableModel model = (DefaultTableModel) gui.getJTable().getModel();   
        
        String[] titles = new String[]{"First Name", "Last Name", "Address", "City", "State", "Zip Code", "HomeType", "Price"};
         
        Object[][] myHomesArray = new Object[homes.size()][8];       
        
        //loading array
        for(int i = 0; i < homes.size(); i++)
        {
            myHomesArray[i][0] = homes.get(i).getHomesFName();    
            System.out.println(homes.get(i).getHomesFName());
            System.out.println(homes.get(i).getHomesLName());
            myHomesArray[i][1] = homes.get(i).getHomesLName();
            System.out.println(homes.get(i).getAddress());
            myHomesArray[i][2] = homes.get(i).getAddress();
            System.out.println(homes.get(i).getCity());
            myHomesArray[i][3] = homes.get(i).getCity();
            System.out.println(homes.get(i).getState());
            myHomesArray[i][4] = homes.get(i).getState();
            System.out.println(homes.get(i).getZipCode());
            myHomesArray[i][5] = homes.get(i).getZipCode();
            System.out.println(homes.get(i).getHomeType());
            myHomesArray[i][6] = homes.get(i).getHomeType();
            System.out.println(homes.get(i).getPrice());
            myHomesArray[i][7] = homes.get(i).getPrice();
        }
        
        //passing array
        model.setDataVector(myHomesArray, titles);
 
    }
            
    public void showRecord(Homes obj)
    {
        ArrayList<Homes> homes = selectSpecificRecord(obj);
        
        DefaultTableModel model = (DefaultTableModel) gui.getJTable().getModel();   
        
        String[] titles = new String[]{"First Name", "Last Name", "Address", "City", "State", "Zip Code", "HomeType", "Price"};
        
        Object[][] myHomesArray = new Object[homes.size()][8];   
        
        //loading array
        for(int i = 0; i < homes.size(); i++)
        {
            myHomesArray[i][0] = homes.get(i).getHomesFName();    
            myHomesArray[i][1] = homes.get(i).getHomesLName();
            myHomesArray[i][2] = homes.get(i).getAddress();
            myHomesArray[i][3] = homes.get(i).getCity();
            myHomesArray[i][4] = homes.get(i).getState();
            myHomesArray[i][5] = homes.get(i).getZipCode();
            myHomesArray[i][6] = homes.get(i).getHomeType();
            myHomesArray[i][7] = homes.get(i).getPrice();
        }
        
        //passing array
        model.setDataVector(myHomesArray, titles);
 
    }
    
    
    
    public ArrayList<Homes> getHomes()
    {
        ArrayList<Homes> homes = new ArrayList<Homes>();
        String homesQuery = "SELECT * FROM HomeOrders";
        
        try{
            stmt = conn.createStatement();
            rs = stmt.executeQuery(homesQuery);
            Homes home;
            
            while(rs.next())
            {
                home = new Homes();       
                //obtaining the home information
                home.setHomesFName(rs.getString("HomesFName"));
                home.setHomesLName(rs.getString("HomesLName"));
                home.setAddress(rs.getString("Address"));  
                home.setCity(rs.getString("City"));
                home.setState(rs.getString("State"));
                home.setZipCode(rs.getString("ZipCode"));
                home.setHomeType(rs.getString("HomeType"));
                home.setPrice(rs.getString("Price"));
                homes.add(home);         
                
            }
        }
        catch(SQLException e){
            e.printStackTrace();
        }
                
        return homes;            
    }
         
    
    public void updateDb(Homes obj)
    {
        String sql = "UPDATE HOMEORDERS SET HomesFName = ?, HomesLName = ?, Address = ?, City = ?, State = ?, ZipCode = ?, HomeType = ?, WHERE Price = ?";
 
        try{
            //to update database information, allowing change to the values
            pstmt = conn.prepareStatement(sql);
            pstmt.setString(1, obj.HomesFName);
            pstmt.setString(2, obj.HomesLName);
            pstmt.setString(3, obj.Address);
            pstmt.setString(4, obj.City);
            pstmt.setString(5, obj.State);
            pstmt.setString(6, obj.ZipCode);
            pstmt.setString(7, obj.HomeType);
            pstmt.setString(8, obj.Price);
            pstmt.executeUpdate();              //updates the information entered.
            conn.commit();          
            pstmt.close();
        } catch (SQLException e) {
            System.out.println(e.getMessage());
        }
    }
    

    public ArrayList<Homes> selectSpecificRecord(Homes ast)
    {
        ArrayList<Homes> homes = new ArrayList<Homes>();
        String sql = "SELECT * FROM HOMEORDERS WHERE Price = ?";
        
        try
        {
         pstmt = conn.prepareStatement(sql);
         pstmt.setString(1, ast.Price);
         
         ResultSet result = pstmt.executeQuery();
         
         if(result.next()) {
             //to select a specific home owner
             ast.setHomesFName(result.getString("HomesFName"));
             ast.setHomesLName(result.getString("HomesLName"));
             ast.setAddress(result.getString("Address"));
             ast.setCity(result.getString("City"));
             ast.setState(result.getString("State"));
             ast.setZipCode(result.getString("ZipCode"));
             ast.setHomeType(result.getString("HomeType"));
             ast.setPrice(result.getString("Price"));
             homes.add(ast);         
         }
        }
        catch (SQLException e)
        {
           System.out.println("There was a SQL error during SELECT; " + e);
        }
        
        try
        {
        pstmt.close();
        }
        catch (SQLException e)
        {
           System.out.println("Error closing SQL select statement " + e);
        }
        return homes;
    }
    
    public void deleteDb(Homes obj)
    {
        String sql = "DELETE FROM HOMEORDERS WHERE Price = ?";
 
        try{
            
            pstmt = conn.prepareStatement(sql);     //removing a home owner
            pstmt.setString(1, obj.Price);
            pstmt.executeUpdate();
            conn.commit();
            pstmt.close();
 
        } catch (SQLException e) {
            System.out.println(e.getMessage());
        }
    
    }
    
    public void insertDb(Homes obj)
    {
        System.out.println("About to insert into table");
        //adding a new home owner
        System.out.println(obj.HomesFName);
        System.out.println(obj.HomesLName);
        System.out.println(obj.Address);
        System.out.println(obj.City);
        System.out.println(obj.State);
        System.out.println(obj.ZipCode);
        System.out.println(obj.HomeType);
        System.out.println(obj.Price);
        
        try
        {
         //adding the various values into the insert
         SQLString = "INSERT INTO HomeOrders VALUES"
                 + "(?,?,?,?,?,?,?,?)";
         pstmt = conn.prepareStatement(SQLString);
         pstmt.setString(1, obj.HomesFName);
         pstmt.setString(2, obj.HomesLName);
         pstmt.setString(3, obj.Address);
         pstmt.setString(4, obj.City);
         pstmt.setString(5, obj.State);
         pstmt.setString(6, obj.ZipCode);
         pstmt.setString(7, obj.HomeType);
         pstmt.setString(8, obj.Price);
         pstmt.executeUpdate();
         conn.commit();
         pstmt.close();
            
        }catch(SQLException ex)
        {
            Logger.getLogger(CRUD.class.getName()).log(Level.SEVERE, null, ex);
            System.out.println("Error: " + ex.getMessage());
        }

    }
}
